<script setup lang="ts">
    import { graphql } from "./../../gql/index";
    import { computed } from "vue";
    import useNavigationStore from "./../../stores/navigation";
    import { useQuery } from "@vue/apollo-composable";
    import { useRouter } from "vue-router";
    import { DynamicRoutePaths } from "../../plugins/router";

    const navigationStore = useNavigationStore();
    const router = useRouter();

    const props = defineProps<{
        callName: string;
        givenName: string;
        familyName: string;
        birthDate: string;
    }>();

    // all hashes query
    const allHashesQuery = graphql(`
        query AllHashes {
            allHashes {
                hash
                participantId
            }
        }
    `);
    const { result: allHashesResult } = useQuery(allHashesQuery, null, {
        fetchPolicy: "cache-and-network",
    });
    const allHashes = computed(() => {
        return allHashesResult.value?.allHashes ?? [];
    });

    // current hashes query
    const currentHashesQueryVariables = computed(() => {
        return {
            birthDate: props.birthDate,
            familyName: props.familyName,
            callName: props.callName,
            givenName: props.givenName,
        };
    });
    const currentHashesQuery = graphql(`
        query CurrentHashes($birthDate: Date!, $familyName: String!, $callName: String!, $givenName: String!) {
            tryHashes(birthDate: $birthDate, familyName: $familyName, givenName: $givenName, callName: $callName)
        }
    `);
    const { result: currentHashesResult } = useQuery(currentHashesQuery, currentHashesQueryVariables, {
        fetchPolicy: "cache-and-network",
    });
    const currentHashes = computed(() => {
        return currentHashesResult.value?.tryHashes ?? [];
    });

    const possibleParticipants = computed(() => {
        let res = {} as { [key: string]: number };

        if (currentHashes.value.length != 0 && allHashes.value.length) {
            currentHashes.value.forEach((hashToTest) => {
                allHashes.value.forEach((comparison) => {
                    if (hashToTest == comparison.hash) {
                        if (!(comparison.participantId in res)) {
                            res[comparison.participantId] = 0;
                        }
                        res[comparison.participantId] += 1;
                    }
                });
            });
        }

        return res;
    });

    const numberPossibleParticipants = computed(() => {
        return Object.keys(possibleParticipants.value).length;
    });

    function showParticipant(id: string) {
        navigationStore.participantId = id;
        router.push({ name: DynamicRoutePaths.ParticipantDetails });
    }
</script>

<template>
    <v-card title="Achtung: Teilnehmer in Datenbank gefunden" variant="tonal" class="my-2" v-if="numberPossibleParticipants != 0">
        <template v-slot:text>
            <p>Das Ziel ist es, dass jede Person nur einmal in der Datenbank angelegt ist.</p>
            <p>
                Die aktuellen Werte von <b>Vorname</b>, <b>Familienname</b>, <b>Rufname</b> und <b>Geburtsdatum</b> legen nahe,
                dass diese Person bereits einen Eintrag hat.
            </p>
            <p>
                Da die persönlichen Daten regelmäßig gelöscht werden müssen und wir anhand von anonymisierten Hashes auf
                vorhanden-sein testen, kann diese Warnung falsch liegen.
            </p>
            <p>Versuche alle vier Felder zu setzen um die Präzision zu erhöhen. Dann prüfe die Einträge manuell auf Validität.</p>

            <v-row class="my-2">
                <div class="v-col-12" v-for="(numberHits, partId) in possibleParticipants">
                    <v-btn size="small" @click="showParticipant(partId as string)">
                        <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                        Teilnehmer anzeigen
                    </v-btn>

                    <span class="ml-4"> Hat {{ numberHits }} von aktuell {{ currentHashes.length }} Hashes assoziiert. </span>
                </div>
            </v-row>

            <p>
                Wenn du nicht weißt was das bedeutet, weil man dir nur eine Liste an Anmeldungen zu Eingabe gegeben hat, dann frag
                bitte nach :-).
            </p>
        </template>
    </v-card>
</template>
